#!/usr/bin/env python
"""
Usage: vdr-applet.py [OPTIONS]

OPTIONS:
    -h, --help      Show this help
    -w, --window    Start in window mode
"""
import pygtk
pygtk.require('2.0')

import getopt
import gtk
import gnomeapplet
import sys
import vdrapplet

def build_window(popup_mode=False):
    app = gtk.Window(gtk.WINDOW_TOPLEVEL)
    app.set_title("VDR Applet")
    app.connect("destroy", gtk.main_quit)
    
    applet = gnomeapplet.Applet()    
    vdr_factory(applet, None)
    applet.reparent(app)
        
    app.show_all()
    gtk.main()
    return

def vdr_factory(applet, iid):
    label = gtk.Label("Success!")
    
    vdrapplet.VdrApplet(applet)
    
    return True

if __name__=='__main__':
    in_window = False
    
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hw", ["help", "window",])
    except getopt.GetoptError:
        print __doc__
        sys.exit()
    
    for o, a in opts:
        if o in ("-h", "--help"):
            print __doc__
            sys.exit()
        elif o in ("-w", "--window"):
            in_window = True
            
    if in_window:
        build_window()
    else:
        gnomeapplet.bonobo_factory("OAFIID:VDR_Applet_Factory", 
                             gnomeapplet.Applet.__gtype__,
                             "VDR Applet",
                             vdrapplet.__version__,
                             vdr_factory)