import sys
import pygtk
pygtk.require('2.0')
import gtk
import gnome
import subprocess
import vdrapplet

class VdrApplet:
    
    def __init__(self, applet):
        gnome.init(vdrapplet.__doc__, vdrapplet.__version__)
        
        self.applet = applet        
        applet.connect("destroy", self.cleanup)
        
        self.__build_widgets()
        
        applet.add(self.buttonbox)
        applet.show_all()
        
    def __build_widgets(self):
        self.pw_entry = gtk.Entry()
        self.pw_entry.connect('key-press-event', self.__on_pw_entry_key_press_event)
        self.pw_entry.set_visibility(False)
        self.pw_entry.show()
        
        self.buttonbox = gtk.HBox()
        self.status_image = gtk.Image()
        self.__set_enabled(False)
        self.buttonbox.pack_start(self.status_image, False)
        
        self.buttonbox.pack_start(gtk.SeparatorToolItem(), False, False)
        
        self.button_start = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_SMALL_TOOLBAR ))
        self.button_start.connect('clicked', self.__on_button_clicked, 'start')
        self.buttonbox.pack_start(self.button_start)
        
        self.button_stop = gtk.ToolButton(gtk.image_new_from_stock(gtk.STOCK_MEDIA_STOP, gtk.ICON_SIZE_SMALL_TOOLBAR ))                
        self.button_stop.connect('clicked', self.__on_button_clicked, 'stop')
        self.buttonbox.pack_start(self.button_stop)
        
    def __on_button_clicked(self, button, option):
        self.option = option
        self.__display_pw_entry(True)
        return True
    
    def __on_pw_entry_key_press_event(self, entry, event):
        if event.keyval == gtk.keysyms.Escape:
            self.__display_pw_entry(False)
        elif event.keyval == gtk.keysyms.Return:
            if self.__run_vdr():
                self.__set_enabled((self.option == 'start'))
            self.__display_pw_entry(False)
            
    def __set_enabled(self, status):
        if status:
            self.status_image.set_from_stock(gtk.STOCK_YES, gtk.ICON_SIZE_SMALL_TOOLBAR)
        else:
            self.status_image.set_from_stock(gtk.STOCK_NO, gtk.ICON_SIZE_SMALL_TOOLBAR)
    
    def __display_pw_entry(self, status):
        if status:
            self.applet.remove(self.buttonbox)
            self.applet.add(self.pw_entry)
            self.pw_entry.grab_focus()
        else:
            self.applet.remove(self.pw_entry)
            self.pw_entry.set_text('')
            self.applet.add(self.buttonbox)
        
    def __run_vdr(self):
        s = subprocess.Popen("sudo -S /etc/init.d/vdr %s" % self.option,
                         shell=True, stdin=subprocess.PIPE, close_fds=True)
        s.stdin.write(self.pw_entry.get_text())
        s.wait()
        if s.returncode == 0:
            return True
        else:
            return False
        
    def cleanup(self, applet):
        pass